diff --git a/src/main/java/net/minecraft/client/render/RenderGlobal.java b/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 7e9751ea6..1fdd7fd59 100644
--- a/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -2,41 +2,41 @@ package net.minecraft.client.render;
 
 import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.entity.fx.EntityFX;
-import net.minecraft.client.entity.fx.ParticleDispatcher;
+import net.minecraft.client.entity.particle.Particle;
+import net.minecraft.client.entity.particle.ParticleDispatcher;
 import net.minecraft.client.gui.GuiPhotoMode;
 import net.minecraft.client.gui.modelviewer.GuiModelViewer;
 import net.minecraft.client.option.enums.RenderDistance;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
-import net.minecraft.client.render.block.model.BlockModelLeaves;
+import net.minecraft.client.render.block.model.LeavesBlockModel;
 import net.minecraft.client.render.camera.EntityCamera;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.client.render.culling.CameraFrustum;
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.HitResult;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.MusicDiscItem;
+import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.Item;
-import net.minecraft.core.item.ItemRecord;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.BoundingVolume;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.AuroraProvider;
-import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.season.Seasons;
-import net.minecraft.core.world.weather.Weather;
+import net.minecraft.core.world.weather.Weathers;
 import org.lwjgl.opengl.ARBOcclusionQuery;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL15;
@@ -53,16 +53,16 @@ import static org.lwjgl.opengl.GL11.*;
 //            IWorldAccess, GLAllocation, RenderList, OpenGlCapsChecker, 
 //            Tessellator, World, RenderManager, RenderBlocks,
 //            Block, GameSettings, BlockLeaves, WorldRenderer, 
-//            Entity, MathHelper, EntitySorter, TileEntityRenderer, 
-//            ICamera, EntityLiving, TileEntity, RenderHelper, 
+//            Entity, MathHelper, EntitySorter, BlockEntityRenderer,
+//            ICamera, Mob, BlockEntity, RenderHelper,
 //            EntityRenderer, WorldProvider, Vec3D, RenderEngine, 
-//            RenderSorter, MovingObjectPosition, EntityPlayer, EnumMovingObjectType, 
-//            AxisAlignedBB, GuiIngame, SoundManager, EntityBubbleFX, 
+//            RenderSorter, MovingObjectPosition, Player, EnumMovingObjectType,
+//            AxisAlignedBB, GuiIngame, SoundEngine, EntityBubbleFX,
 //            EffectRenderer, EntitySmokeFX, EntityNoteFX, EntityPortalFX, 
 //            EntityExplodeFX, EntityFlameFX, EntityLavaFX, EntityFootStepFX, 
 //            EntitySplashFX, EntityReddustFX, EntityItemFX, Item,
 //            EntitySnowShovelFX, EntityHeartFX, ImageBufferDownload, StepSound, 
-//            ItemRecord, ItemStack
+//            MusicDiscItem, ItemStack
 
 public class RenderGlobal
     implements LevelListener
@@ -165,7 +165,7 @@ public class RenderGlobal
             double d11 = java.lang.Math.atan2(java.lang.Math.sqrt(d * d + d2 * d2), d1);
             double d12 = java.lang.Math.sin(d11);
             double d13 = java.lang.Math.cos(d11);
-            double d14 = random.nextDouble() * 3.1415926535897931D * 2D;
+            double d14 = random.nextDouble() * Math.PI * 2D;
             double d15 = java.lang.Math.sin(d14);
             double d16 = java.lang.Math.cos(d14);
             for(int j = 0; j < 4; j++)
@@ -218,7 +218,7 @@ public class RenderGlobal
         deleteRenderListBase();
         glRenderListBase = GLAllocation.generateDisplayLists(RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH * 3);
 
-        BlockModelLeaves.setGraphicsLevel(mc.gameSettings.fancyGraphics.value == 1);
+        LeavesBlockModel.setGraphicsLevel(mc.gameSettings.fancyGraphics.value == 1);
         renderDistance = mc.gameSettings.renderDistance.value;
         if (worldObj == null) return;
 
@@ -227,7 +227,7 @@ public class RenderGlobal
         {
             for (ChunkRenderer chunkRenderer : chunkRenderers)
             {
-                chunkRenderer.reset();
+                chunkRenderer.delete();
             }
         }
         int renderDiameterBlocks = renderDistance.chunks * 16 * 2;
@@ -250,7 +250,7 @@ public class RenderGlobal
         maxBlockZ = renderChunksDeep;
         for (ChunkRenderer cr : chunkRenderersToUpdate)
         {
-            cr.needsUpdate = false;
+            cr.dirty = false;
         }
 
         chunkRenderersToUpdate.clear();
@@ -262,16 +262,16 @@ public class RenderGlobal
                 for(int z = 0; z < renderChunksDeep; z++)
                 {
                     int index = (z * renderChunksTall + y) * renderChunksWide + x;
-                    chunkRenderers[index] = new ChunkRenderer(renderEngine, worldObj, tileEntities, x * RENDER_CHUNK_SIZE, y * RENDER_CHUNK_SIZE, z * RENDER_CHUNK_SIZE, RENDER_CHUNK_SIZE, glRenderListBase + renderListOffset);
+                    chunkRenderers[index] = new ChunkRenderer(worldObj, tileEntities, x * RENDER_CHUNK_SIZE, y * RENDER_CHUNK_SIZE, z * RENDER_CHUNK_SIZE, RENDER_CHUNK_SIZE, glRenderListBase + renderListOffset);
                     if(occlusionEnabled)
                     {
-                        chunkRenderers[index].glOcclusionQuery = glOcclusionQueryBase.get(chunkIndex);
+                        chunkRenderers[index].occlusionId = glOcclusionQueryBase.get(chunkIndex);
                     }
-                    chunkRenderers[index].isWaitingOnOcclusionQuery = false;
-                    chunkRenderers[index].isVisible = true;
-                    chunkRenderers[index].isInFrustum = true;
-                    chunkRenderers[index].chunkIndex = chunkIndex++;
-                    chunkRenderers[index].markDirty();
+                    chunkRenderers[index].occlusionQuerying = false;
+                    chunkRenderers[index].occlusionVisible = true;
+                    chunkRenderers[index].visible = true;
+                    chunkRenderers[index].id = chunkIndex++;
+                    chunkRenderers[index].setDirty();
                     sortedChunkRenderers[index] = chunkRenderers[index];
                     chunkRenderersToUpdate.add(chunkRenderers[index]);
                     renderListOffset += ChunkRenderer.MAX_RENDER_PASSES + 1;
@@ -285,7 +285,7 @@ public class RenderGlobal
         {
             if (mc.activeCamera != null)
             {
-                markRenderersForNewPosition(MathHelper.floor_double(mc.activeCamera.getX()), MathHelper.floor_double(mc.activeCamera.getY()), MathHelper.floor_double(mc.activeCamera.getZ()));
+                markRenderersForNewPosition(MathHelper.floor(mc.activeCamera.getX()), MathHelper.floor(mc.activeCamera.getY()), MathHelper.floor(mc.activeCamera.getZ()));
                 Arrays.sort(sortedChunkRenderers, new CameraSorter(mc.activeCamera));
             }
         }
@@ -351,7 +351,7 @@ public class RenderGlobal
         double rotationX = Math.cos(((cameraYaw * Math.PI) / 180D));
         double rotationZ = Math.sin(((cameraYaw * Math.PI) / 180D));
 
-        renderEngine.bindTexture(renderEngine.getTexture("%blur%/environment/aurora.png"));
+        renderEngine.bindTexture(renderEngine.loadTexture("/assets/minecraft/textures/environment/aurora.png"));
         double time = worldObj.getWorldTime() + partialTick;
         AuroraProvider aurora = worldObj.auroraProvider;
 
@@ -413,7 +413,7 @@ public class RenderGlobal
             renderEntitiesStartupCounter--;
             return;
         }
-        TileEntityRenderDispatcher.instance.cacheActiveRenderInfo(worldObj, renderEngine, mc.fontRenderer, camera, partialTick);
+        BlockEntityRenderDispatcher.instance.cacheActiveRenderInfo(worldObj, renderEngine, mc.fontRenderer, camera, partialTick);
         EntityRenderDispatcher.instance.cacheActiveRenderInfo(worldObj, renderEngine, mc.fontRenderer, camera, mc.gameSettings, partialTick);
         countEntitiesTotal = 0;
         countEntitiesRendered = 0;
@@ -421,9 +421,9 @@ public class RenderGlobal
         EntityRenderDispatcher.renderPosX = camera.getX(partialTick);
         EntityRenderDispatcher.renderPosY = camera.getY(partialTick);
         EntityRenderDispatcher.renderPosZ = camera.getZ(partialTick);
-        TileEntityRenderDispatcher.renderPosX = camera.getX(partialTick);
-        TileEntityRenderDispatcher.renderPosY = camera.getY(partialTick);
-        TileEntityRenderDispatcher.renderPosZ = camera.getZ(partialTick);
+        BlockEntityRenderDispatcher.renderPosX = camera.getX(partialTick);
+        BlockEntityRenderDispatcher.renderPosY = camera.getY(partialTick);
+        BlockEntityRenderDispatcher.renderPosZ = camera.getZ(partialTick);
         List<Entity> loadedEntities = worldObj.getLoadedEntityList();
         countEntitiesTotal = loadedEntities.size();
         Tessellator tessellator = Tessellator.instance;
@@ -432,7 +432,7 @@ public class RenderGlobal
         {
             Entity entity = worldObj.weatherEffects.get(i);
             countEntitiesRendered++;
-            if(entity.shouldRender(camera.getPosition(partialTick)))
+            if(entity.shouldRender(camera.getPosition(partialTick)) || mc.thePlayer.vehicle == entity)
             {
                 EntityRenderDispatcher.instance.renderEntity(tessellator, entity, partialTick);
             }
@@ -442,18 +442,18 @@ public class RenderGlobal
         for (int i = 0; i < loadedEntities.size(); i++)
         {
             Entity entity = loadedEntities.get(i);
-            if (mc.activeCamera != null && mc.activeCamera instanceof EntityCamera && ((EntityCamera) mc.activeCamera).entity == entity)
+            if (mc.activeCamera != null && mc.activeCamera instanceof EntityCamera && ((EntityCamera) mc.activeCamera).mob == entity)
             {
                 if (!mc.activeCamera.showPlayer())
                 {
                     continue;
                 }
             }
-            if (!entity.shouldRender(camera.getPosition(partialTick)) || !entity.ignoreFrustumCheck && !camera.getFrustum().isVisible(entity.bb, partialTick))
+            if (mc.thePlayer.vehicle != entity && (!entity.shouldRender(camera.getPosition(partialTick)) || !entity.ignoreFrustumCheck && !camera.getFrustum().isVisible(entity.bb, partialTick)))
             {
                 continue;
             }
-            int floorY = MathHelper.floor_double(entity.y);
+            int floorY = MathHelper.floor(entity.y);
             if (floorY < 0)
             {
                 floorY = 0;
@@ -463,16 +463,16 @@ public class RenderGlobal
                 floorY = worldObj.getHeightBlocks() - 1;
 
             }
-            if (worldObj.isBlockLoaded(MathHelper.floor_double(entity.x), floorY, MathHelper.floor_double(entity.z)))
+            if (worldObj.isBlockLoaded(MathHelper.floor(entity.x), floorY, MathHelper.floor(entity.z)) || mc.thePlayer.vehicle == entity)
             {
                 countEntitiesRendered++;
                 EntityRenderDispatcher.instance.renderEntity(tessellator, entity, partialTick);
             }
         }
 
-        for (TileEntity tileEntity : tileEntities)
+        for (BlockEntity blockEntity : tileEntities)
         {
-            TileEntityRenderDispatcher.instance.renderTileEntity(tessellator, tileEntity, partialTick);
+            BlockEntityRenderDispatcher.instance.renderTileEntity(tessellator, blockEntity, partialTick);
         }
     }
 
@@ -547,9 +547,9 @@ public class RenderGlobal
                         maxBlockY = i3;
                     }
                     ChunkRenderer worldrenderer = chunkRenderers[(i2 * renderChunksTall + l2) * renderChunksWide + j1];
-                    boolean flag = worldrenderer.needsUpdate;
-                    worldrenderer.setPosition(k1, i3, j2);
-                    if(!flag && worldrenderer.needsUpdate)
+                    boolean flag = worldrenderer.dirty;
+                    worldrenderer.setPos(k1, i3, j2);
+                    if(!flag && worldrenderer.dirty)
                     {
                         chunkRenderersToUpdate.add(worldrenderer);
                     }
@@ -567,7 +567,7 @@ public class RenderGlobal
         {
             worldRenderersCheckIndex = (worldRenderersCheckIndex + 1) % chunkRenderers.length;
             ChunkRenderer chunkRenderer = chunkRenderers[worldRenderersCheckIndex];
-            if(chunkRenderer.needsUpdate && !chunkRenderersToUpdate.contains(chunkRenderer))
+            if(chunkRenderer.dirty && !chunkRenderersToUpdate.contains(chunkRenderer))
             {
                 chunkRenderersToUpdate.add(chunkRenderer);
             }
@@ -596,7 +596,7 @@ public class RenderGlobal
             prevSortX = camera.getX();
             prevSortY = camera.getY();
             prevSortZ = camera.getZ();
-            markRenderersForNewPosition(MathHelper.floor_double(camera.getX()), MathHelper.floor_double(camera.getY()), MathHelper.floor_double(camera.getZ()));
+            markRenderersForNewPosition(MathHelper.floor(camera.getX()), MathHelper.floor(camera.getY()), MathHelper.floor(camera.getZ()));
             Arrays.sort(sortedChunkRenderers, new CameraSorter(camera));
         }
         Lighting.disable();
@@ -608,7 +608,7 @@ public class RenderGlobal
             checkOcclusionQueryResult(min, max);
             for(int i = min; i < max; i++)
             {
-                sortedChunkRenderers[i].isVisible = true;
+                sortedChunkRenderers[i].occlusionVisible = true;
             }
 
             k += renderSortedRenderers(min, max, renderPass, partialTick);
@@ -620,10 +620,10 @@ public class RenderGlobal
                 {
                     max = sortedChunkRenderers.length;
                 }
-                GL11.glDisable(3553 /*GL_TEXTURE_2D*/);
-                GL11.glDisable(2896 /*GL_LIGHTING*/);
-                GL11.glDisable(3008 /*GL_ALPHA_TEST*/);
-                GL11.glDisable(2912 /*GL_FOG*/);
+                GL11.glDisable(GL11.GL_TEXTURE_2D);
+                GL11.glDisable(GL11.GL_LIGHTING);
+                GL11.glDisable(GL11.GL_ALPHA_TEST);
+                GL11.glDisable(GL11.GL_FOG);
                 GL11.glColorMask(false, false, false, false);
                 GL11.glDepthMask(false);
                 checkOcclusionQueryResult(byte0, max);
@@ -633,16 +633,16 @@ public class RenderGlobal
                 float f2 = 0.0F;
                 for(int k1 = byte0; k1 < max; k1++)
                 {
-                    if(sortedChunkRenderers[k1].skipAllRenderPasses())
+                    if(sortedChunkRenderers[k1].isEmpty())
                     {
-                        sortedChunkRenderers[k1].isInFrustum = false;
+                        sortedChunkRenderers[k1].visible = false;
                         continue;
                     }
-                    if(!sortedChunkRenderers[k1].isInFrustum)
+                    if(!sortedChunkRenderers[k1].visible)
                     {
-                        sortedChunkRenderers[k1].isVisible = true;
+                        sortedChunkRenderers[k1].occlusionVisible = true;
                     }
-                    if(!sortedChunkRenderers[k1].isInFrustum || sortedChunkRenderers[k1].isWaitingOnOcclusionQuery)
+                    if(!sortedChunkRenderers[k1].visible || sortedChunkRenderers[k1].occlusionQuerying)
                     {
                         continue;
                     }
@@ -653,9 +653,9 @@ public class RenderGlobal
                         continue;
                     }
                     ChunkRenderer worldrenderer1 = sortedChunkRenderers[k1];
-                    float f4 = (float)((double)worldrenderer1.posXMinus - entityPosX);
-                    float f5 = (float)((double)worldrenderer1.posYMinus - entityPosY);
-                    float f6 = (float)((double)worldrenderer1.posZMinus - entityPosZ);
+                    float f4 = (float)((double)worldrenderer1.xRender - entityPosX);
+                    float f5 = (float)((double)worldrenderer1.yRender - entityPosY);
+                    float f6 = (float)((double)worldrenderer1.zRender - entityPosZ);
                     float f7 = f4 - f;
                     float f8 = f5 - f1;
                     float f9 = f6 - f2;
@@ -666,18 +666,18 @@ public class RenderGlobal
                         f1 += f8;
                         f2 += f9;
                     }
-                    ARBOcclusionQuery.glBeginQueryARB(35092 /*GL_SAMPLES_PASSED_ARB*/, sortedChunkRenderers[k1].glOcclusionQuery);
-                    sortedChunkRenderers[k1].callOcclusionQueryList();
+                    ARBOcclusionQuery.glBeginQueryARB(35092 /*GL_SAMPLES_PASSED_ARB*/, sortedChunkRenderers[k1].occlusionId);
+                    sortedChunkRenderers[k1].renderBB();
                     ARBOcclusionQuery.glEndQueryARB(35092 /*GL_SAMPLES_PASSED_ARB*/);
-                    sortedChunkRenderers[k1].isWaitingOnOcclusionQuery = true;
+                    sortedChunkRenderers[k1].occlusionQuerying = true;
                 }
 
                 GL11.glPopMatrix();
                 GL11.glColorMask(true, true, true, true);
                 GL11.glDepthMask(true);
-                GL11.glEnable(3553 /*GL_TEXTURE_2D*/);
-                GL11.glEnable(3008 /*GL_ALPHA_TEST*/);
-                GL11.glEnable(2912 /*GL_FOG*/);
+                GL11.glEnable(GL11.GL_TEXTURE_2D);
+                GL11.glEnable(GL11.GL_ALPHA_TEST);
+                GL11.glEnable(GL11.GL_FOG);
                 k += renderSortedRenderers(byte0, max, renderPass, partialTick);
             } while(max < sortedChunkRenderers.length);
         }
@@ -692,18 +692,18 @@ public class RenderGlobal
     {
         for(int i = min; i < max; i++)
         {
-            if(!sortedChunkRenderers[i].isWaitingOnOcclusionQuery)
+            if(!sortedChunkRenderers[i].occlusionQuerying)
             {
                 continue;
             }
             occlusionResult.clear();
-            ARBOcclusionQuery.glGetQueryObjectuARB(sortedChunkRenderers[i].glOcclusionQuery, GL15.GL_QUERY_RESULT_AVAILABLE, occlusionResult);
+            ARBOcclusionQuery.glGetQueryObjectuivARB(sortedChunkRenderers[i].occlusionId, GL15.GL_QUERY_RESULT_AVAILABLE, occlusionResult);
             if(occlusionResult.get(0) != 0)
             {
-                sortedChunkRenderers[i].isWaitingOnOcclusionQuery = false;
+                sortedChunkRenderers[i].occlusionQuerying = false;
                 occlusionResult.clear();
-                ARBOcclusionQuery.glGetQueryObjectuARB(sortedChunkRenderers[i].glOcclusionQuery, GL15.GL_QUERY_RESULT, occlusionResult);
-                sortedChunkRenderers[i].isVisible = occlusionResult.get(0) != 0;
+                ARBOcclusionQuery.glGetQueryObjectuivARB(sortedChunkRenderers[i].occlusionId, GL15.GL_QUERY_RESULT, occlusionResult);
+                sortedChunkRenderers[i].occlusionVisible = occlusionResult.get(0) != 0;
             }
         }
 
@@ -718,15 +718,15 @@ public class RenderGlobal
             if(renderPass == 0)
             {
                 renderersLoaded++;
-                if(sortedChunkRenderers[i].skipRenderPass[renderPass])
+                if(sortedChunkRenderers[i].empty[renderPass])
                 {
                     renderersSkippingRenderPass++;
                 }
-                else if (!sortedChunkRenderers[i].isInFrustum)
+                else if (!sortedChunkRenderers[i].visible)
                 {
                     renderersBeingClipped++;
                 }
-                else if (occlusionEnabled && !sortedChunkRenderers[i].isVisible)
+                else if (occlusionEnabled && !sortedChunkRenderers[i].occlusionVisible)
                 {
                     renderersBeingOccluded++;
                 } else
@@ -734,11 +734,11 @@ public class RenderGlobal
                     renderersBeingRendered++;
                 }
             }
-            if(sortedChunkRenderers[i].skipRenderPass[renderPass] || !sortedChunkRenderers[i].isInFrustum || occlusionEnabled && !sortedChunkRenderers[i].isVisible)
+            if(sortedChunkRenderers[i].empty[renderPass] || !sortedChunkRenderers[i].visible || occlusionEnabled && !sortedChunkRenderers[i].occlusionVisible)
             {
                 continue;
             }
-            int callList = sortedChunkRenderers[i].getGLCallListForPass(renderPass);
+            int callList = sortedChunkRenderers[i].getList(renderPass);
             if(callList >= 0)
             {
                 glRenderLists.add(sortedChunkRenderers[i]);
@@ -760,7 +760,7 @@ public class RenderGlobal
             int displayListIndex = -1;
             for (int i = 0; i < k1; i++)
             {
-                if (allDisplayLists[i].isSetToPos(chunkRenderer.posXMinus, chunkRenderer.posYMinus, chunkRenderer.posZMinus))
+                if (allDisplayLists[i].isSetToPos(chunkRenderer.xRender, chunkRenderer.yRender, chunkRenderer.zRender))
                 {
                     displayListIndex = i;
                 }
@@ -769,9 +769,9 @@ public class RenderGlobal
             if (displayListIndex < 0)
             {
                 displayListIndex = k1++;
-                allDisplayLists[displayListIndex].setToPos(chunkRenderer.posXMinus, chunkRenderer.posYMinus, chunkRenderer.posZMinus, posX, posY, posZ);
+                allDisplayLists[displayListIndex].setToPos(chunkRenderer.xRender, chunkRenderer.yRender, chunkRenderer.zRender, posX, posY, posZ);
             }
-            allDisplayLists[displayListIndex].addCallToList(chunkRenderer.getGLCallListForPass(renderPass));
+            allDisplayLists[displayListIndex].addCallToList(chunkRenderer.getList(renderPass));
         }
 
         if (!mc.gameSettings.fog.value)
@@ -826,10 +826,10 @@ public class RenderGlobal
         }
         float celestialAngle = worldObj.getCelestialAngle(partialTick);
         GL11.glDisable(GL_TEXTURE_2D);
-        Vec3d skyColor = worldObj.getSkyColor(mc.activeCamera, partialTick);
-        float r = (float)skyColor.xCoord;
-        float g = (float)skyColor.yCoord;
-        float b = (float)skyColor.zCoord;
+        Vec3 skyColor = worldObj.getSkyColor(mc.activeCamera, partialTick);
+        float r = (float)skyColor.x;
+        float g = (float)skyColor.y;
+        float b = (float)skyColor.z;
         GL11.glColor3f(r, g, b);
         Tessellator t = Tessellator.instance;
         GL11.glDepthMask(false);
@@ -873,8 +873,8 @@ public class RenderGlobal
         GL11.glEnable(GL_TEXTURE_2D);
         GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE);
         GL11.glPushMatrix();
-        float sunAlpha = 1.0F - (worldObj.getCurrentWeather() != null && worldObj.getCurrentWeather() != Weather.overworldClear ? (worldObj.weatherManager.getWeatherIntensity() * worldObj.weatherManager.getWeatherPower()) * 1.5f : 0.0f);
-        if (!mc.gameSettings.fog.value && worldObj.getCurrentWeather() == Weather.overworldFog)
+        float sunAlpha = 1.0F - (worldObj.getCurrentWeather() != null && worldObj.getCurrentWeather() != Weathers.OVERWORLD_CLEAR ? (worldObj.weatherManager.getWeatherIntensity() * worldObj.weatherManager.getWeatherPower()) * 1.5f : 0.0f);
+        if (!mc.gameSettings.fog.value && worldObj.getCurrentWeather() == Weathers.OVERWORLD_FOG)
         {
             sunAlpha = 1f;
         }
@@ -888,7 +888,7 @@ public class RenderGlobal
 
         // Render sun
         float f15 = 30F;
-        GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, renderEngine.getTexture("/terrain/sun.png"));
+        renderEngine.loadTexture("/terrain/sun.png").bind();
         GL11.glColor4f(1.0F, 1.0F, 1.0F, sunAlpha);
         t.startDrawingQuads();
         t.addVertexWithUV(-f15, 100D, -f15, 0.0D, 0.0D);
@@ -899,7 +899,7 @@ public class RenderGlobal
 
         // Render moon
         f15 = 20F;
-        GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, renderEngine.getTexture("/terrain/moon.png"));
+        renderEngine.loadTexture("/terrain/moon.png").bind();
         GL11.glColor4f(1.0F, 1.0F, 1.0F, sunAlpha);
         t.startDrawingQuads();
         t.addVertexWithUV(-f15, -100D, f15, 1.0D, 1.0D);
@@ -908,7 +908,7 @@ public class RenderGlobal
         t.addVertexWithUV(-f15, -100D, -f15, 1.0D, 0.0D);
         t.draw();
 
-        GL11.glDisable(3553 /*GL_TEXTURE_2D*/);
+        GL11.glDisable(GL11.GL_TEXTURE_2D);
         float f17 = worldObj.getStarBrightness(partialTick) * sunAlpha;
         if(f17 > 0.0F)
         {
@@ -916,9 +916,9 @@ public class RenderGlobal
             GL11.glCallList(starGLCallList);
         }
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        GL11.glDisable(3042 /*GL_BLEND*/);
-        GL11.glEnable(3008 /*GL_ALPHA_TEST*/);
-        GL11.glEnable(2912 /*GL_FOG*/);
+        GL11.glDisable(GL11.GL_BLEND);
+        GL11.glEnable(GL11.GL_ALPHA_TEST);
+        GL11.glEnable(GL11.GL_FOG);
         GL11.glPopMatrix();
         if(worldObj.worldType.hasGround())
         {
@@ -927,7 +927,7 @@ public class RenderGlobal
         {
             GL11.glColor3f(r, g, b);
         }
-        GL11.glEnable(3553 /*GL_TEXTURE_2D*/);
+        GL11.glEnable(GL11.GL_TEXTURE_2D);
         GL11.glDepthMask(true);
     }
 
@@ -950,23 +950,23 @@ public class RenderGlobal
             renderCloudsFancy(partialTick);
             return;
         }
-        GL11.glDisable(2884 /*GL_CULL_FACE*/);
+        GL11.glDisable(GL11.GL_CULL_FACE);
         float cameraY = (float) mc.activeCamera.getY(partialTick);
         byte cloudRadius = 32;
         int i = 256 / cloudRadius;
         Tessellator tessellator = Tessellator.instance;
-        GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, renderEngine.getTexture("/environment/clouds.png"));
-        GL11.glEnable(3042 /*GL_BLEND*/);
+        renderEngine.loadTexture("/assets/minecraft/textures/environment/clouds.png").bind();
+        GL11.glEnable(GL11.GL_BLEND);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        Vec3d dimensionColor = worldObj.getDimensionColor(mc.activeCamera, partialTick);
-        float r = (float)dimensionColor.xCoord;
-        float g = (float)dimensionColor.yCoord;
-        float b = (float)dimensionColor.zCoord;
+        Vec3 dimensionColor = worldObj.getDimensionColor(mc.activeCamera, partialTick);
+        float r = (float)dimensionColor.x;
+        float g = (float)dimensionColor.y;
+        float b = (float)dimensionColor.z;
         float f6 = 1f / 2048f;
         double posX = mc.activeCamera.getX(partialTick) + (double)((lastCloudOffsetX + (cloudOffsetX - lastCloudOffsetX) * partialTick) * 0.03F);
         double posZ = mc.activeCamera.getZ(partialTick) + (double)((lastCloudOffsetZ + (cloudOffsetZ - lastCloudOffsetZ) * partialTick) * 0.03F);
-        int j = MathHelper.floor_double(posX / 2048D);
-        int k = MathHelper.floor_double(posZ / 2048D);
+        int j = MathHelper.floor(posX / 2048D);
+        int k = MathHelper.floor(posZ / 2048D);
         posX -= j * 2048;
         posZ -= k * 2048;
         float cloudHeight = (worldObj.worldType.getCloudHeight() - cameraY) + 0.33F + getCloudHeightModifier();
@@ -988,8 +988,8 @@ public class RenderGlobal
 
         tessellator.draw();
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        GL11.glDisable(3042 /*GL_BLEND*/);
-        GL11.glEnable(2884 /*GL_CULL_FACE*/);
+        GL11.glDisable(GL11.GL_BLEND);
+        GL11.glEnable(GL11.GL_CULL_FACE);
     }
 
     public void renderCloudsFancy(float partialTick)
@@ -1006,10 +1006,10 @@ public class RenderGlobal
             aSun = sunriseColor[3] / 2;
         }
 
-        Vec3d dimensionColor = worldObj.getDimensionColor(mc.activeCamera, partialTick);
-        final float rDim = (float)dimensionColor.xCoord;
-        final float gDim = (float)dimensionColor.yCoord;
-        final float bDim = (float)dimensionColor.zCoord;
+        Vec3 dimensionColor = worldObj.getDimensionColor(mc.activeCamera, partialTick);
+        final float rDim = (float)dimensionColor.x;
+        final float gDim = (float)dimensionColor.y;
+        final float bDim = (float)dimensionColor.z;
 
         GL11.glDisable(GL11.GL_CULL_FACE);
         float cameraY = (float) mc.activeCamera.getY(partialTick);
@@ -1019,18 +1019,18 @@ public class RenderGlobal
         double dx = (mc.activeCamera.getX(partialTick) + (double)((lastCloudOffsetX + (cloudOffsetX - lastCloudOffsetX) * partialTick) * 0.03F)) / (double)cloudWidth;
         double dz = (mc.activeCamera.getZ(partialTick) + (double)((lastCloudOffsetZ + (cloudOffsetZ - lastCloudOffsetZ) * partialTick) * 0.03F)) / (double)cloudWidth + 0.33D;
         float dy = (worldObj.worldType.getCloudHeight() - cameraY) + 0.33F + getCloudHeightModifier();
-        int i = MathHelper.floor_double(dx / 2048D);
-        int j = MathHelper.floor_double(dz / 2048D);
+        int i = MathHelper.floor(dx / 2048D);
+        int j = MathHelper.floor(dz / 2048D);
         dx -= i * 2048;
         dz -= j * 2048;
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, renderEngine.getTexture("/environment/clouds.png"));
+        renderEngine.loadTexture("/assets/minecraft/textures/environment/clouds.png").bind();
         GL11.glEnable(GL11.GL_BLEND);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
         float f13 = 1F / 256F;
-        float f9 = (float) MathHelper.floor_double(dx) * f13;
-        float f11 = (float) MathHelper.floor_double(dz) * f13;
-        float f14 = (float)(dx - (double) MathHelper.floor_double(dx));
-        float f15 = (float)(dz - (double) MathHelper.floor_double(dz));
+        float f9 = (float) MathHelper.floor(dx) * f13;
+        float f11 = (float) MathHelper.floor(dz) * f13;
+        float f14 = (float)(dx - (double) MathHelper.floor(dx));
+        float f15 = (float)(dz - (double) MathHelper.floor(dz));
         int cloudWidthScale = 8;
         byte radius = 3;
         float f16 = 1F / 1024F;
@@ -1136,8 +1136,8 @@ public class RenderGlobal
         }
 
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        GL11.glDisable(3042 /*GL_BLEND*/);
-        GL11.glEnable(2884 /*GL_CULL_FACE*/);
+        GL11.glDisable(GL11.GL_BLEND);
+        GL11.glEnable(GL11.GL_CULL_FACE);
         
     	mc.renderer.endRenderClouds(partialTick);
     }
